/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

void frmFrame::init()
{
	mdl = 0;

	mnuMain = new QPopupMenu();
	mnuMain->insertItem( "Add frame", this,
		SLOT( on_add_frame()), 0, 0);
	mnuMain->insertItem( "Update frame", this,
		SLOT( on_update_frame()), 0, 4);
	mnuMain->insertItem( "Delete frame", this,
		SLOT( on_delete_frame()), 0, 1);
	mnuMain->insertSeparator();
	mnuMain->insertItem( "Rename frame", this,
		SLOT( on_rename_frame()), 0, 2);
	mnuMain->insertItem( "Add to sequence", this,
		SLOT( on_add_to_sequence()), 0, 3);
}


void frmFrame::destroy()
{
	if( mnuMain) delete mnuMain;
}


void frmFrame::on_add_frame()
{
	sk3DRomSkelFrame &s = mdl->mdl.skel.skout;
	s.set_name( "untitled");
	mdl->mdl.add_skeleton_frame( s);
	lstFrame->insertItem( s.get_name());
	mdl->modified = true;
}


void frmFrame::on_delete_frame()
{
	const int n = lstFrame->currentItem();
	if( n < 0) return;
	mdl->mdl.skel.delete_skeleton_frame( n);
	on_populate_frame_list();
	mdl->frmSeq->on_populate_frame_list();
	mdl->modified = true;
}


void frmFrame::on_rename_frame()
{
	const int n = lstFrame->currentItem();
	if( n < 0) return;
	bool ok;
	QString text = QInputDialog::getText(
		"Rename Frame", "Name:", QLineEdit::Normal,
		mdl->mdl.skel.sf[n].get_name(), &ok, this);
	if( ok && !text.isEmpty()) {
		mdl->mdl.skel.sf[n].set_name( text);
		lstFrame->changeItem( text, n);
		mdl->frmSeq->on_populate_frame_list();
		mdl->modified = true;
	}
}


void frmFrame::on_add_to_sequence()
{
	std::cerr << "Add to sequence\n";
}


void frmFrame::on_show_menu()
{
	const int n = lstFrame->currentItem();
	if( (n < 0) || !(lstFrame->isSelected( n))) {
		mnuMain->setItemVisible( 1, false);
		mnuMain->setItemVisible( 2, false);
		mnuMain->setItemVisible( 3, false);
		mnuMain->setItemVisible( 4, false);

	} else {
		mnuMain->setItemVisible( 1, true);
		mnuMain->setItemVisible( 2, true);
		mnuMain->setItemVisible( 3, true);
		mnuMain->setItemVisible( 4, true);
	}
	mnuMain->popup( QCursor::pos());
}


void frmFrame::on_populate_frame_list()
{
	lstFrame->clear();
	for( int i = 0; i < mdl->mdl.skeleton_count(); i++)
		lstFrame->insertItem( mdl->mdl.skel.sf[i].get_name());
}


void frmFrame::on_activate_frame()
{
	const int n = lstFrame->currentItem();
	if( n < 0) return;
	mdl->mdl.skel.skout = mdl->mdl.skel.sf[n];
	mdl->mdl.transform_skel_frame();
	mdl->update_all_views();
}


void frmFrame::on_update_frame()
{
	const int n = lstFrame->currentItem();
	if( n < 0) return;
	mdl->mdl.skel.sf[n] = mdl->mdl.skel.skout;
}

void frmFrame::on_do_drag()
{
	const int n = lstFrame->currentItem();
	if( (n < 0) || !(lstFrame->isSelected( n))) return;
	QString s;
	QDragObject *d = new QTextDrag(
		s.setNum( lstFrame->currentItem()), this);
        d->dragCopy();	// do NOT delete d.
}


