/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

void frmMain::fileNew()
{
	Model *m = krn_create_new_model( mdl);
	
	// Create a view window for this model.
	m->create_view_window( wrkspc);
	m->show_all_view_windows();
	
}

void frmMain::fileOpen()
{
	// Ask the user for the file they want to open
        QString s = QFileDialog::getOpenFileName(
                QString::null,
                "3DRom (*.3dr);;"
                "All files (*)",
                this,
                "Open Model",
                "Choose a file to open");
        if( s.isNull()) return;
                                   
	// Open the new model
	Model *m = krn_create_new_model( mdl);
        const int err = m->mdl.load( s);
        if( err) {
                QMessageBox::critical( this,
                        "Could not open model",
                        "Error " + QString::number( err) + ".",
                        QMessageBox::Ok,
                        QMessageBox::NoButton,
                        QMessageBox::NoButton);
		krn_delete_model( m);
                return;
        }
	// Memorize the model's file name for future saves.
	m->fname = s;

	m->frmGrp->build_group_list();
	m->frmTex->populate_texture_list();
	m->frmTex->populate_page_list();
	m->frmSkel->on_populate_frame_list();
	m->frmSeq->on_populate_sequence_list();
	m->frmSeq->on_populate_target_bone_list();

	// Create a view window for this model.
	krn_create_model_view_window( *m);

	//m->create_view_window( wrkspc);
	m->show_all_view_windows();
}

void frmMain::filePrint()
{

}

void frmMain::fileExit()
{

}

void frmMain::editUndo()
{

}

void frmMain::editRedo()
{

}

void frmMain::editCut()
{

}

void frmMain::editCopy()
{

}

void frmMain::editPaste()
{

}

void frmMain::editFind()
{

}

void frmMain::helpIndex()
{

}

void frmMain::helpContents()
{

}

void frmMain::helpAbout()
{

}

void frmMain::init()
{
	wrkspc = new QWorkspace( frmMDI);
	wrkspc->setScrollBarsEnabled( TRUE);
	wrkspc_layout = new QHBoxLayout( frmMDI, 0);
	wrkspc_layout->addWidget( wrkspc);

	krn_create_main_tool_buttons( this);

	prev_edMode = edMode = KED_MODE_NONE;
}

void frmMain::destroy()
{
	if( wrkspc) delete wrkspc;
	if( wrkspc_layout) delete wrkspc_layout;

	close_all_models();
}


void frmMain::close_all_models()
{
	while( !(mdl.empty())) {
		if( mdl[0]) delete (mdl[0]);
		mdl.erase( mdl.begin());
	}
}


void frmMain::on_camera_translate_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_CAMERA_TRAN;
}

void frmMain::on_camera_rotate_Y_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_CAMERA_YROT;
}

void frmMain::on_camera_rotate_X_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_CAMERA_XROT;
}

void frmMain::on_camera_rotate_Z_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_CAMERA_ZROT;
}

void frmMain::on_camera_scale_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_CAMERA_SCALE;
}


void frmMain::on_add_vertex_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_ADD_VERT;
}


void frmMain::on_add_triangle_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_ADD_TRI;
}




void frmMain::on_select_vertex_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_SEL_VERT;
}


void frmMain::on_select_bone_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_SEL_BONE;
	for( int i = 0; i < int( model.size()); i++) {
		(model[i])->do_bone_bind = false;
		(model[i])->do_bone_mount = false;
	}
}

void frmMain::on_add_bone_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_ADD_BONE;
}


void frmMain::on_rotate_selection_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_ROTATE;
}


void frmMain::on_select_triangle_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_SEL_TRI;
}


void frmMain::on_scale_selection_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_SCALE;
}


void frmMain::on_select_brush_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_SEL_BRUSH;
}

void frmMain::on_add_brush_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_ADD_BRUSH;
}


void frmMain::on_scale_brush_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_SCALE_BRUSH;
}

void frmMain::on_rotate_brush_mode()
{
	prev_edMode = edMode;
	edMode = KED_MODE_ROTATE_BRUSH;
}
