/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

void frmSequence::init()
{
	mdl = 0;
	m_dc = 0;
	m_playing = false;
	m_paused = false;

	mnuMain = new QPopupMenu();
	mnuMain->insertItem( "Add sequence", this,
		SLOT( on_add_sequence()), 0, 0);
	mnuMain->insertItem( "Delete sequence", this,
		SLOT( on_delete_sequence()), 0, 1);
	mnuMain->insertSeparator();
	mnuMain->insertItem( "Rename sequence", this,
		SLOT( on_rename_sequence()), 0, 2);

	mnuFrame = new QPopupMenu();
	//mnuFrame->insertItem( "Add frame", this,
	//	SLOT( on_add_frame()), 0, 0);
	mnuFrame->insertItem( "Delete frame", this,
		SLOT( on_delete_frame()), 0, 1);
	//mnuFrame->insertItem( "Change frame", this,
	//	SLOT( on_change_frame()), 0, 2);

	// FIXME: There should be a better way to identify widget stacks
	//	than by index number.
	//
	//	Currently, the blank widget stack is stack number 1.
	wstkData->raiseWidget( 1);
	wstkData->setEnabled( false);
	frmTimeAndCode->setEnabled( false);
	frmSeqEdit->setEnabled( false);

	tmrSeq = new QTimer();
	connect( tmrSeq, SIGNAL( timeout()), this, SLOT( on_timer()));
}


void frmSequence::on_add_sequence()
{
	sk3DRomSequence *s = mdl->mdl.add_sequence( sk3DRomSequence());
	s->set_name( "Untitled");
	lstSeq->insertItem( gen_seq_list_text( mdl->mdl.sequence_count() - 1));
}

void frmSequence::on_delete_sequence()
{
	const int n = lstSeq->currentItem();
	if( n < 0) return;
	mdl->mdl.delete_sequence( n);
	on_populate_sequence_list();
	on_populate_frame_list();
}

void frmSequence::on_rename_sequence()
{
	const int n = lstSeq->currentItem();
	if( n < 0) return;
	bool ok;
	const QString text = QInputDialog::getText(
		"Rename Sequence", "Enter sequence name:", QLineEdit::Normal,
		(mdl->mdl.sequence(n))->get_name(), &ok, this );
	if( ok && !text.isEmpty()) {
		mdl->mdl.set_sequence_name( n, text);
		lstSeq->changeItem( gen_seq_list_text( n), n);
	}
}


void frmSequence::on_show_seq_menu()
{
	const int n = lstSeq->currentItem();
	if( (n < 0) || !(lstSeq->isSelected( n))) {
		mnuMain->setItemVisible( 1, false);
		mnuMain->setItemVisible( 2, false);

	} else {
		mnuMain->setItemVisible( 1, true);
		mnuMain->setItemVisible( 2, true);
	}
	mnuMain->popup( QCursor::pos());
}


void frmSequence::on_populate_sequence_list()
{
	lstSeq->clear();
	for( int i = 0; i < mdl->mdl.sequence_count(); i++)
		lstSeq->insertItem( gen_seq_list_text( i));
}


void frmSequence::destroy()
{
	if( mnuMain) delete mnuMain;
	if( tmrSeq) delete tmrSeq;
	if( m_dc) delete m_dc;
}


void frmSequence::on_delete_frame()
{
	mdl->mdl.delete_sequence_frame( lstSeq->currentItem(),
		lstFrame->currentItem());
	on_populate_frame_list();
	on_populate_frame_data( lstSeq->currentItem(),
		lstFrame->currentItem());
}


void frmSequence::on_drop_frame( QDropEvent *e )
{
	const int sid = lstSeq->currentItem();
	if( (sid < 0) || !(lstSeq->isSelected( sid))) return;
	const sk3DRomSequence *s = mdl->mdl.sequence( sid);
	QString text;
	if( QTextDrag::decode( e, text)) {
		const int fid = text.toInt();
		if( (fid < 0) || (fid >= mdl->mdl.skeleton_count())) return;
		sk3DRomAniFrame *f = mdl->mdl.add_sequence_frame( sid);
		if( f) f->set_fid( fid);
	        lstFrame->insertItem( gen_frame_list_text( *s,
			s->frame_count() - 1));
	}
}


void frmSequence::on_drag_enter( QDragEnterEvent *e )
{
	if ( QTextDrag::canDecode( e)) e->accept();
}


QString frmSequence::gen_seq_list_text( int sid )
{
	QString s;
	s.sprintf( "[%d] ", sid);
	if( (sid < 0) || (sid >= mdl->mdl.sequence_count())) return s;
	s += (mdl->mdl.sequence( sid))->get_name();
	return s;
}


void frmSequence::on_select_sequence()
{
	const int n = lstSeq->currentItem();
	if( (n < 0) || !(lstSeq->isSelected( n))) {
		frmSeqEdit->setEnabled( false);
		return;
	}

	on_populate_frame_list();
	on_select_frame();
	frmSeqEdit->setEnabled( true);
}


void frmSequence::on_populate_frame_list()
{
	lstFrame->clear();
	if( !(lstSeq->isSelected( lstSeq->currentItem()))) return;
	const sk3DRomSequence *s = mdl->mdl.sequence( lstSeq->currentItem());
	if( !s) return;
	for( int i = 0; i < s->frame_count(); i++)
		lstFrame->insertItem( gen_frame_list_text( *s, i));
}

QString frmSequence::gen_frame_list_text( const sk3DRomSequence &s, int n )
{
	QString tmp;
	tmp.sprintf( "[%d] ", n);
	if( (n < 0) || (n >= s.frame_count())) return tmp;
	tmp += (mdl->mdl.skel.sf[ (s.frame[n]).fid()]).get_name();
	return tmp;
}


void frmSequence::on_change_frame_code()
{
	const int sid = lstSeq->currentItem();
	const int fid = lstFrame->currentItem();
	if( !(lstSeq->isSelected( sid)) || !(lstFrame->isSelected( fid))) return;
	sk3DRomAniFrame *f = mdl->mdl.get_editable_ani_frame( sid, fid);

	f->set_code( cmbCode->currentItem());
	switch( cmbCode->currentItem()) {
	case SK3DROM_ANI_CODE_TRANSITION:
	case SK3DROM_ANI_CODE_STOP:
		wstkData->raiseWidget( 1);
		break;

	case SK3DROM_ANI_CODE_JUMP:
		{
			//sk3DRomAniFrame_jump tmp;
			//tmp.init_data( *f);
			wstkData->raiseWidget( 0);
		}
		break;
	}
}


void frmSequence::on_select_frame()
{
	const int sid = lstSeq->currentItem();
	const int fid = lstFrame->currentItem();
	if( !(lstSeq->isSelected( sid)) || !(lstFrame->isSelected( fid))) {
		wstkData->setEnabled( false);
		frmTimeAndCode->setEnabled( false);
		return;
	}

	on_populate_frame_data( sid, fid);
	wstkData->setEnabled( true);
	frmTimeAndCode->setEnabled( true);
}


void frmSequence::on_populate_frame_data( int sid, int fid )
{
	// FIXME: "sid" or "fid" can be invalid.
	const sk3DRomAniFrame &f = (mdl->mdl.sequence( sid))->frame[ fid];
	sboxTime->setValue( f.time());
	cmbCode->setCurrentItem( f.code());
	on_change_frame_code();
	switch( f.code()) {
	case SK3DROM_ANI_CODE_JUMP:
		{
			sk3DRomAniFrame_jump jmp;
			sboxSkip->setValue( jmp.get_times_to_skip( f));
			QString s;
			s.setNum( jmp.get_probability( f));
			txtProb->setText( s);
			sboxDelay->setValue( jmp.get_delay( f));
			sboxSeqDes->setValue( jmp.get_des_sequence( f));
			sboxFrmDes->setValue( jmp.get_des_frame( f));
			cmbLockType->setCurrentItem( jmp.get_lock_type( f));
			cmbTargetBone->setCurrentItem( jmp.get_target_bone( f));
		}
		break;
	}
	
}

void frmSequence::on_apply_frame_data()
{
	const int sid = lstSeq->currentItem();
	const int fid = lstFrame->currentItem();
	if( !(lstSeq->isSelected( sid)) || !(lstFrame->isSelected( fid))) return;
	sk3DRomAniFrame *f = mdl->mdl.get_editable_ani_frame( sid, fid);

	f->set_time( sboxTime->value());
	switch( f->code()) {
	case SK3DROM_ANI_CODE_JUMP:
		{
			sk3DRomAniFrame_jump jmp;
			jmp.set_times_to_skip( *f, sboxSkip->value());
			jmp.set_probability( *f, (txtProb->text()).toFloat());
			jmp.set_delay( *f, sboxDelay->value());
			jmp.set_des_sequence( *f, sboxSeqDes->value());
			jmp.set_des_frame( *f, sboxFrmDes->value());
			jmp.set_lock_type( *f, get_lock_type());
			jmp.set_target_bone( *f, cmbTargetBone->currentItem());
		}
		break;
	}
	
}


void frmSequence::on_timer()
{
	if( m_paused) return;
	mdl->mdl.skel.animate( 17, m_dc);
	mdl->mdl.transform_skel_frame( m_dc);
	mdl->update_all_views();
}


void frmSequence::on_play_sequence()
{
	if( m_dc) delete m_dc;
	m_dc = new sk3DRomDrawContext();
	const int sid = lstSeq->currentItem();
	if( (sid >= 0) && !(mdl->mdl.sequence( sid))->frame.empty()) {
		mdl->mdl.skel.skout =
			mdl->mdl.skel.sf[ (mdl->mdl.sequence( sid))->
				frame[0].fid()];
	}
	if( m_dc) {
		m_dc->m_skout = mdl->mdl.skel.skout;
		m_dc->init_fcs( mdl->mdl.skel);
	}
	mdl->mdl.skel.animate( sid, 0, 1, 1, m_dc);
	tmrSeq->start( 17, false);
	m_playing = true;
	m_paused = false;
	btnPause->setText( "Pause");
}


void frmSequence::on_stop_sequence()
{
	tmrSeq->stop();
	mdl->mdl.skel.m_draw_context.reset_orientation();
	mdl->mdl.transform_skel_frame();
	mdl->update_all_views();
	m_playing = false;
	m_paused = false;
	btnPause->setText( "Pause");
}


void frmSequence::on_populate_target_bone_list()
{
	cmbTargetBone->clear();
	for( int i = 0; i < int( mdl->mdl.skel.b.size()); i++) {
		if( strlen( mdl->mdl.skel.b[i].name()) <= 0) {
			QString s;
			s.sprintf( "[%d] untitled", i);
			cmbTargetBone->insertItem( s);
		} else cmbTargetBone->insertItem( mdl->mdl.skel.b[i].name());
	}
}




int frmSequence::get_lock_type()
{
	switch( cmbLockType->currentItem()) {
	case 1: return SK3DROM_ANI_LOCK_TYPE_JOINT;
	case 2: return SK3DROM_ANI_LOCK_TYPE_BONE;
	case 3: return SK3DROM_ANI_LOCK_TYPE_YAXIS;
	default: return SK3DROM_ANI_LOCK_TYPE_NONE;
	}
}


void frmSequence::on_show_frame_menu()
{
	const int n = lstFrame->currentItem();
	if( (n < 0) || !(lstFrame->isSelected( n))) {
		mnuFrame->setItemVisible( 1, false);

	} else {
		mnuFrame->setItemVisible( 1, true);
	}
	mnuFrame->popup( QCursor::pos());
}


void frmSequence::on_pause_sequence()
{
	if( !m_playing) return;
	m_paused = !m_paused;
	if( m_paused) btnPause->setText( "Resume");
	else btnPause->setText( "Pause");
}
