/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

void frmTexPage::init()
{
	(statusBar())->hide();
	layPage = new QHBoxLayout( frmPage);
	layTex = new QHBoxLayout( frmTex);

	mdl = 0;
	mnuPageList = new QPopupMenu( this, 0);
	mnuPageList->insertItem( "Add Page", this,
		SLOT( on_add_page()), 0, 0);
	mnuPageList->insertItem( "Delete Page", this,
		SLOT( on_delete_page()), 0, 1);
	mnuPageList->insertItem( "Rename Page", this,
		SLOT( on_rename_page()), 0, 2);
	mnuPageList->insertSeparator();
	mnuPageList->insertItem( "Composite page", this,
		SLOT( on_composite_page()), 0, 3);
	mnuPageList->insertItem( "Generate Stencil", this,
		SLOT( on_gen_stencil()), 0, 4);

	mnuTexList = new QPopupMenu( this, 0);
	mnuTexList->insertItem( "Add texture", this,
		SLOT( on_add_texture()), 0, 0);
	mnuTexList->insertItem( "Delete texture", this,
		SLOT( on_delete_texture()), 0, 1);
	mnuTexList->insertSeparator();
	mnuTexList->insertItem( "Bind to selected page", this,
		SLOT( on_bind_texture()), 0, 2);

	mnuPage = new QPopupMenu( this, 0);
	mnuPage->insertItem( "Reset page view", this,
		SLOT( on_reset_page_view()), 0, 0);
	mnuPage->insertItem( "Generate Stencil", this,
		SLOT( on_gen_stencil()), 0, 1);
	mnuPage->insertItem( "Select all", this,
		SLOT( on_page_select_all()), 0, 2);
	mnuPage->insertSeparator();
	mnuPage->insertItem( "left justify selected...", this,
		SLOT( on_page_left_justify()), 0, 100);
	mnuPage->insertItem( "right justify selected...", this,
		SLOT( on_page_right_justify()), 0, 101);
	mnuPage->insertItem( "top justify selected...", this,
		SLOT( on_page_top_justify()), 0, 102);
	mnuPage->insertItem( "bottom justify selected...", this,
		SLOT( on_page_bottom_justify()), 0, 103);
	mnuPage->insertSeparator();
	mnuPage->insertItem( "scale selected...", this,
		SLOT( on_page_scale_selected()), 0, 104);
	mnuPage->insertItem( "scale selected U Coord...", this,
		SLOT( on_page_scale_selected_ucoord()), 0, 105);
	mnuPage->insertItem( "scale selected V Coord...", this,
		SLOT( on_page_scale_selected_vcoord()), 0, 106);
	mnuPage->insertItem( "scale selected to unit texture...", this,
		SLOT( on_page_scale_sel_to_unit()), 0, 107);
	mnuPage->insertItem( "scale to bordered unit texture...", this,
		SLOT( on_page_scale_border_unit()), 0, 108);
}


void frmTexPage::on_add_page()
{
	sk3DRomModel &m = mdl->mdl;
	m.set_page_name( m.add_page(), "Untitled");
	populate_page_list();
}

void frmTexPage::on_delete_page()
{
	const int n = lstPage->currentItem();
	if( n < 0) return;
	mdl->mdl.delete_page( n);
	populate_page_list();
}

void frmTexPage::on_rename_page()
{
	const int n = lstPage->currentItem();
	if( n < 0) return;
	bool ok;
	QString text = QInputDialog::getText(
		"Rename Page", "Enter page name:", QLineEdit::Normal,
		(mdl->mdl.page(n))->page_name(), &ok, this );
	if( ok && !text.isEmpty()) {
		mdl->mdl.set_page_name( n, text.latin1());
		lstPage->changeItem( text, n);
	}
}

void frmTexPage::destroy()
{
	if( mnuPageList) delete mnuPageList;
	if( glvPage) delete glvPage;
	if( glvTex) delete glvTex;
	if( layPage) delete layPage;
	if( layTex) delete layTex;
}


void frmTexPage::on_highlight_page()
{
	PageViewData &pvd = *((PageViewData *)glvPage->edata);
	pvd.show_sel_box = false;
	pvd.clear_selected_face();
	glvPage->updateGL();

	const int pid = lstPage->currentItem();
	if( pid < 0) return;
	if( (pvd.frm->mdl->mdl.page( pid))->world_map())
		cmbMapMode->setCurrentItem( 1);
	else if( (pvd.frm->mdl->mdl.page( pid))->local_map())
		cmbMapMode->setCurrentItem( 2);
	else cmbMapMode->setCurrentItem( 0);

	sk3DRomTexturePage *p = mdl->mdl.edit_page( pid);
	if( !p) return;
	QString s;
	txtUScale->setText( s.setNum( p->uscale()));
	txtVScale->setText( s.setNum( p->vscale()));

	//if( p->world_texture()) chkWorldTexture->setChecked( true);
	//else chkWorldTexture->setChecked( false);
	chkWorldTexture->setChecked( bool( p->world_texture()));
	chkPageEnabled->setChecked( bool( p->page_enabled()));
}


void frmTexPage::on_show_page_menu()
{
	const int n = lstPage->currentItem();
	if( (n < 0) || !(lstPage->isSelected( n))) {
		mnuPageList->setItemVisible( 1, false);
		mnuPageList->setItemVisible( 2, false);
		mnuPageList->setItemVisible( 3, false);
		mnuPageList->setItemVisible( 4, false);
	} else {
		mnuPageList->setItemVisible( 1, true);
		mnuPageList->setItemVisible( 2, true);
		mnuPageList->setItemVisible( 3, true);
		mnuPageList->setItemVisible( 4, true);
	}

	mnuPageList->exec( QCursor::pos());
}


void frmTexPage::populate_page_list()
{
	lstPage->clear();
	const int istop = mdl->mdl.page_count();
	for( int i = 0; i < istop; i++)
		lstPage->insertItem( (mdl->mdl.page( i))->page_name());
}


void frmTexPage::populate_texture_list()
{
	lstTex->clear();
	const int istop = mdl->mdl.texture_count();
	for( int i = 0; i < istop; i++)
		lstTex->insertItem( mdl->mdl.texture[i].full_path());
}


void frmTexPage::on_add_texture()
{
	QString s = QFileDialog::getOpenFileName( 0,
		"Windows Bit maps (*.bmp)", this, "Add Texture",
		"Choose a file");
	if( s.isEmpty()) return;
	sk3DRomTexture &t = mdl->mdl.texture[ mdl->mdl.add_texture()];
	t.load( s);
	populate_texture_list();
	glvTex->updateGL();
}


void frmTexPage::on_delete_texture()
{
	const int n = lstTex->currentItem();
	if( n < 0) return;
	mdl->mdl.delete_texture( n);
	populate_texture_list();
	glvPage->updateGL();
}


void frmTexPage::on_show_texture_menu()
{
	const int n = lstTex->currentItem();
	if( (n < 0) || !(lstTex->isSelected( n))) {
		mnuTexList->setItemVisible( 1, false);
	} else {
		mnuTexList->setItemVisible( 1, true);
	}

	mnuTexList->exec( QCursor::pos());
}


void frmTexPage::on_paint_texture_view()
{
	do_paintGL_texture_view( this);
}


void frmTexPage::on_initGL_texture_view()
{
	do_initGL_texture_view( this);
}


void frmTexPage::create_views( GLView *v )
{
	glvTex = new GLView( frmTex, 0, v);
	glvPage = new GLView( frmPage, 0, glvTex);
	glvPage->setMinimumSize( QSize( 64, 64));
	glvPage->setFocusPolicy( QWidget::StrongFocus);
	layPage->addWidget( glvPage);
	layTex->addWidget( glvTex);

	connect( glvTex, SIGNAL( sig_initializeGL( GLView *)), this,
		SLOT( on_initGL_texture_view()));
	connect( glvTex, SIGNAL( sig_paintGL( GLView *)), this,
		SLOT( on_paint_texture_view()));
	connect( glvTex, SIGNAL( sig_resizeGL( int, int, GLView *)), this,
		SLOT( on_resizeGL_texture_view( int, int)));

	connect( glvPage, SIGNAL( sig_initializeGL( GLView *)), this,
		SLOT( on_initGL_page_view()));
	connect( glvPage, SIGNAL( sig_paintGL( GLView *)), this,
		SLOT( on_paintGL_page_view()));
	connect( glvPage, SIGNAL( sig_resizeGL( int, int, GLView *)), this,
		SLOT( on_resizeGL_page_view( int, int)));
	connect( glvPage, SIGNAL( sig_destroy( GLView *)), this,
		SLOT( on_destroy_page_view()));
	connect( glvPage, SIGNAL( sig_mouse_down( QMouseEvent *, GLView *)),
		this, SLOT( on_mouse_down_page_view( QMouseEvent *, GLView *)));
	connect( glvPage, SIGNAL( sig_mouse_move( QMouseEvent *, GLView *)),
		this, SLOT( on_mouse_move_page_view( QMouseEvent *, GLView *)));
	connect( glvPage, SIGNAL( sig_mouse_up( QMouseEvent *, GLView *)),
		this, SLOT( on_mouse_up_page_view( QMouseEvent *, GLView *)));
	connect( glvPage, SIGNAL( sig_key_down( QKeyEvent *, GLView *)),
		this, SLOT( on_key_down_page_view( QKeyEvent *, GLView *)));
}


void frmTexPage::on_resizeGL_texture_view( int w, int h )
{
	do_resizeGL_texture_view( w, h, this);
}


void frmTexPage::on_highlight_texture()
{
	glvTex->updateGL();
	const int tid = lstTex->currentItem();
	if( (tid < 0) || (tid > mdl->mdl.texture_count())) return;
	chkMipMap->setChecked( (mdl->mdl.texture[tid]).is_mipmapped());
	chkSmooth->setChecked( (mdl->mdl.texture[tid]).is_smooth());
	chkColorKey->setChecked( (mdl->mdl.texture[tid]).is_alpha());
	txtTexName->setText( (mdl->mdl.texture[tid]).m_tname);
	lblColorKey->setPaletteBackgroundColor(
		QColor(	int( (mdl->mdl.texture[tid]).m_colorkey[0]),
			int( (mdl->mdl.texture[tid]).m_colorkey[1]),
			int( (mdl->mdl.texture[tid]).m_colorkey[2])));
}


void frmTexPage::on_paintGL_page_view()
{
	do_paintGL_page_view( this);
}

void frmTexPage::on_initGL_page_view()
{
	do_initGL_page_view( this);
}

void frmTexPage::on_resizeGL_page_view( int w, int h)
{
	do_resizeGL_page_view( w, h, this);
}


void frmTexPage::on_destroy_page_view()
{
	do_destroy_page_view( this);
}


void frmTexPage::on_bind_texture()
{
	const int pid = lstPage->currentItem();
	if( pid < 0) return;
	mdl->mdl.bind_texture_to_page( pid, lstTex->currentItem());
	glvPage->updateGL();
}


void frmTexPage::on_mouse_down_page_view( QMouseEvent *e, GLView *g )
{
	do_mouse_down_page_view( e, g);
}


void frmTexPage::on_mouse_move_page_view( QMouseEvent *e, GLView *g )
{
	do_mouse_move_page_view( e, g, this);
}


void frmTexPage::on_mouse_up_page_view( QMouseEvent *e, GLView *g )
{
	do_mouse_up_page_view( e, g);
}


void frmTexPage::on_key_down_page_view( QKeyEvent *e, GLView *g)
{
	do_key_down_page_view( e, g, this);
}


void frmTexPage::on_composite_page()
{
	const int n = lstPage->currentItem();
	if( n < 0) return;
	bool ok;
	QString text = QInputDialog::getText(
		"Composite Page", "Enter destination page name:", QLineEdit::Normal,
		"", &ok, this );
	if( (!ok) || (text.isEmpty())) return;
	for( int i = 0; i < mdl->mdl.page_count(); i++) {
		if( text == (mdl->mdl.page( i))->page_name())
			mdl->mdl.composite_page( i, n);
	}
}

void frmTexPage::on_gen_stencil()
{
	if( lstPage->currentItem() < 0) return;
	frmGenStencil gsten;
	if( QDialog::Accepted != gsten.exec()) return;
	glvPage->makeCurrent();
	glvPage->updateGL();
	//gbl_app->processEvents();
	{ rgTimer t( 2.0f); while( !t.time_unit_passed());}
	gbl_app->processEvents();
	//{ rgTimer t( 1.0f); while( !t.time_unit_passed());}
	if( gsten.chkWire->isChecked()) glPolygonMode( GL_FRONT_AND_BACK, GL_LINE);
	else glPolygonMode( GL_FRONT_AND_BACK, GL_FILL);
	rgBMP bmp;
	const int err = (mdl->mdl.page( lstPage->currentItem()))->generate_stencil(
		bmp, gsten.spinX->value(), gsten.spinY->value());
	if( err) {
		QString tmp;
		tmp.setNum( err);
		QMessageBox::critical( this, "3DRomED", "Error " + tmp +
			", while generating stencil.");
		return;
	}
	bmp.flip_vertically();
	//std::cerr << "w = " << bmp.getWidth() << ", h = " << bmp.getHeight() << "\n";
	if( bmp.saveThis( gsten.txtFile->text())) {
		QMessageBox::critical( this, "3DRomED",
			"Could not save stencil \"" + gsten.txtFile->text() +
			"\".");
		return;
	}
}


void frmTexPage::on_set_mapping_mode()
{
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	switch( cmbMapMode->currentItem()) {
	case 1: p->set_world_map(); break;
	case 2: p->set_local_map(); break;
	default: p->set_default_map(); break;
	}
}


void frmTexPage::on_set_uscale()
{
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->set_uscale( (txtUScale->text()).toFloat());
	glvPage->updateGL();
}

void frmTexPage::on_set_vscale()
{
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->set_vscale( (txtVScale->text()).toFloat());
	glvPage->updateGL();
}


void frmTexPage::on_page_left_justify()
{
	bool ok;
	double res = QInputDialog::getDouble(
		"Select justification point", "Enter left edge:", 0.0,
		-16777816, 16777816, 6, &ok, this);
	if( !ok) return;
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->left_justify_selected( rgVector( res, 0, 0));
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}


void frmTexPage::on_page_right_justify()
{
	bool ok;
	double res = QInputDialog::getDouble(
		"Select justification point", "Enter right edge:", 0.0,
		-16777816, 16777816, 6, &ok, this);
	if( !ok) return;
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->right_justify_selected( rgVector( res, 0, 0));
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}


void frmTexPage::on_page_top_justify()
{
	bool ok;
	double res = QInputDialog::getDouble(
		"Select justification point", "Enter top edge:", 0.0,
		-16777816, 16777816, 6, &ok, this);
	if( !ok) return;
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->top_justify_selected( rgVector( 0, res, 0));
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}


void frmTexPage::on_page_bottom_justify()
{
	bool ok;
	double res = QInputDialog::getDouble(
		"Select justification point", "Enter bottom edge:", 0.0,
		-16777816, 16777816, 6, &ok, this);
	if( !ok) return;
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->bottom_justify_selected( rgVector( 0, res, 0));
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}


void frmTexPage::on_page_scale_sel_to_unit()
{
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->scale_selected_to_unit_texture();
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}


void frmTexPage::on_page_scale_selected()
{
	bool ok;
	double res = QInputDialog::getDouble(
		"Select scale factor", "Enter scale factor:", 1.0,
		-16777816, 16777816, 6, &ok, this);
	if( !ok) return;
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->scale_selected( res);
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}

void frmTexPage::on_page_scale_selected_ucoord()
{
	bool ok;
	double res = QInputDialog::getDouble(
		"Select scale factor", "Enter scale factor:", 1.0,
		-16777816, 16777816, 6, &ok, this);
	if( !ok) return;
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->scale_selected( res, 1);
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}

void frmTexPage::on_page_scale_selected_vcoord()
{
	bool ok;
	double res = QInputDialog::getDouble(
		"Select scale factor", "Enter scale factor:", 1.0,
		-16777816, 16777816, 6, &ok, this);
	if( !ok) return;
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->scale_selected( 1, res);
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}


void frmTexPage::on_reset_page_view()
{
	reset_page_view( this);
	glvPage->updateGL();
}


void frmTexPage::on_page_select_all()
{
	PageViewData &pvd = *((PageViewData *)glvPage->edata);
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	pvd.clear_sel_box( p);
	if( !p) return;
	p->select_all_vertices();	
	rgVector vmin, vmax;
	p->get_sel_verts_bbox( vmin, vmax);
	pvd.sel_box.set_box( vmin, vmax);
	pvd.show_sel_box = true;
	// XXX: glvPage is auto-updated by previous popupmenu "mnuPage".
}


void frmTexPage::on_toggle_world_texture()
{
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	if( chkWorldTexture->isChecked()) p->set_world_texture();
	else p->unset_world_texture();
	glvPage->updateGL();
}


void frmTexPage::on_toggle_texture_mipmap()
{
	const int tid = lstTex->currentItem();
	if( (tid < 0) || (tid > mdl->mdl.texture_count())) return;
	(mdl->mdl.texture[ tid]).set_mipmap( chkMipMap->isChecked());
}


void frmTexPage::on_page_scale_border_unit()
{
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	mdl->mdl.scale_selected_page_faces_to_unit_texture(
		lstPage->currentItem(), 1.0f);
	((PageViewData *)glvPage->edata)->update_sel_box( p);
	glvPage->updateGL();
}


void frmTexPage::on_set_texture_name()
{
	const int tid = lstTex->currentItem();
	if( (tid < 0) || (tid > mdl->mdl.texture_count())) return;
	(mdl->mdl.texture[ tid]).m_tname = (txtTexName->text()).latin1();
}


void frmTexPage::on_toggle_page_enabled()
{
	sk3DRomTexturePage *p = mdl->mdl.edit_page( lstPage->currentItem());
	if( !p) return;
	p->set_page_enabled( chkPageEnabled->isChecked());
}


void frmTexPage::on_toggle_texture_smooth()
{
	const int tid = lstTex->currentItem();
	if( (tid < 0) || (tid > mdl->mdl.texture_count())) return;
	(mdl->mdl.texture[ tid]).set_smooth( chkSmooth->isChecked());
}


void frmTexPage::on_toggle_texture_colorkey()
{
	const int tid = lstTex->currentItem();
	if( (tid < 0) || (tid > mdl->mdl.texture_count())) return;
	(mdl->mdl.texture[ tid]).set_alpha( chkColorKey->isChecked());
}


void frmTexPage::on_choose_colorkey()
{
	const int tid = lstTex->currentItem();
	if( (tid < 0) || (tid > mdl->mdl.texture_count())) return;
	QColor c = QColorDialog::getColor( lblColorKey->paletteBackgroundColor());
	if( !(c.isValid())) return;
	lblColorKey->setPaletteBackgroundColor( c);
	int tmp[3];
	c.rgb( tmp, tmp + 1, tmp + 2);
	(mdl->mdl.texture[ tid]).m_colorkey[0] = (unsigned char)( tmp[0]);
	(mdl->mdl.texture[ tid]).m_colorkey[1] = (unsigned char)( tmp[1]);
	(mdl->mdl.texture[ tid]).m_colorkey[2] = (unsigned char)( tmp[2]);
}
