/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef TEXTURE_PAGE_SUPPORT_H
#define TEXTURE_PAGE_SUPPORT_H

#include "kernel.h"

class QMouseEvent;
class frmTexPage;
class GLView;

class PageViewData
{
public:
	int mouse_down_x;
	int mouse_down_y;
	bool mouse_moved;

	bool do_cam_scale;

	bool move_sel_vertex;

	bool move_sel_face;
	rgVector sel_face_offset[3];

	bool show_sel_box;
	bool move_sel_box;
	SelectionBox sel_box;

	PageViewData( frmTexPage *p_frm);

	void clear_sel_box( sk3DRomTexturePage *p) {
		sel_box.set_offset( rgVector());
		if( p) {
			p->clear_selected_vertex();
			p->clear_selected_vertices();
		}
		show_sel_box = false;
		move_sel_box = false;
	}

	void update_sel_box( sk3DRomTexturePage *p) {
		if( !p) return;
		rgVector vmin, vmax;
		p->get_sel_verts_bbox( vmin, vmax);
		sel_box.set_box( vmin, vmax);
	}

	int select_face( const rgVector mp) {
		return (m_sel_face = frm->mdl->mdl.select_page_face(
			frm->lstPage->currentItem(), mp));
	}

	void clear_selected_face() { m_sel_face = -1;}
	int sel_face() const { return m_sel_face;}

	frmTexPage *frm;

protected:
	int m_sel_face;
};

void do_initGL_texture_view( frmTexPage *frm);
void do_paintGL_texture_view( frmTexPage *frm);
void do_resizeGL_texture_view( int w, int h, frmTexPage *frm);

void do_initGL_page_view( frmTexPage *frm);
void do_paintGL_page_view( frmTexPage *frm);
void do_resizeGL_page_view( int w, int h, frmTexPage *frm);
void do_destroy_page_view( frmTexPage *frm);
void do_mouse_down_page_view( QMouseEvent *e, GLView *g);
void do_mouse_move_page_view( QMouseEvent *e, GLView *g, frmTexPage *frm);
void do_mouse_up_page_view( QMouseEvent *e, GLView *g);
void do_key_down_page_view( QKeyEvent *e, GLView *g,
	frmTexPage *frm);

void reset_page_view( frmTexPage *frm);
void do_page_popup_menu( PageViewData &pvd, Model &mdl);

#endif
