/*
Copyright (C) 2003-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <iostream>
#include <stdio.h>
#include "rgOBJ_parser.h"

void hf_comment( Obj_parse_data *p)
{
        end_line( *(p->inf));
        p->line++;
        RGOBJ_PARSER_GENERIC_ERROR_CHECK;
}
                                                                                
void hf_unknown( Obj_parse_data *p)
{
        end_line( *(p->inf));
	p->line++;
        RGOBJ_PARSER_GENERIC_ERROR_CHECK;
}
                                                                                
void hf_vertex( Obj_parse_data *p)
{
        std::ifstream &f = *(p->inf);
	rgOBJVertex v;

	int t = f.tellg();
        end_line( *(p->inf));
	int e = f.tellg();
        f.clear( std::ios::goodbit);
        f.seekg( t, std::ios::beg);

	f >> v.x;
	if( f.tellg() >= e) {
		sprintf( p->obj->err_msg,
			"Line %d: Unexpected '\\n' (new line) after "
			"reading X coordinate.",
			p->line);
		p->err = CM_PARSE_ERROR;
		return;
	}
	
	f >> v.y;
	if( f.tellg() >= e) {
		sprintf( p->obj->err_msg,
			"Line %d: Unexpected '\\n' (new line) after "
			"reading Y coordinate.",
			p->line);
		p->err = CM_PARSE_ERROR;
		return;
	}

	f >> v.z;
	if( f.tellg() < e) end_line( f);
	p->line++;

	p->obj->verts.push_back( v);
        RGOBJ_PARSER_GENERIC_ERROR_CHECK;
}

