/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef AI_H
#define AI_H

#include "../things/things.h"

class phAI : public gmThing
{
public:
	RPH_THING_MODULE

	phAI();
	virtual ~phAI();

	std::string type() const { return std::string( "phAI");}
	bool is_a( const std::string &s) const {
		if( s != phAI::type()) return gmThing::is_a( s);
		return true;
	}

	int call_ccmd( const std::string &key, gmCCArg &args);
	std::string list_ccmd( const std::string &p_prefix);

	// Note: If a host is free, then it is dettached.
	ThingControlBlock *get_host() {
		if( (!m_host) || (m_host->is_free())) m_host = 0;
		return m_host;
	}

	bool set_host( ThingControlBlock *t) {
		if( t->is_free()) return false;
		if( !accept_host( t)) return false;
		m_host = t;
		m_host->m_thing->set_ai( tcb());
		return true;
	}


protected:
	static std::map <const std::string, int (*)( const gmCCArg &)> m_ccmd;

	// Some AI's only make sense when controlling specific hosts.
	virtual bool accept_host( ThingControlBlock *t) { return true;}

	friend int phAI_set_host( const gmCCArg &p);

private:
	// What "thing" the AI controls.
	ThingControlBlock *m_host;

	phAI( const phAI &);
	phAI &operator =( const phAI &);
};

#endif
