/*
Copyright (C) 2004-2005 Amour Hassan
                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                                                                                
*/

#include "ai_referee.h"
#include "engine/engine_game.h"
#include <rg3DRom.h>
#include "arena.h"
#include "player.h"
#include "referee.h"

std::map <const std::string, int (*)( const gmCCArg &)> phAI_Referee::m_ccmd;

extern "C" gmThing *spw_phAI_Referee()
{
	return new phAI_Referee();
}

extern "C" int del_phAI_Referee( gmThing *t)
{
	delete t;
	return 0;
}

RPH_THING_MODULE_MAIN_FUNCTION( phAI_Referee)
{
	p_ge->m_thing_manager->add_to_spawn_list( "phAI_Referee",
		spw_phAI_Referee);

	p_ge->m_thing_manager->add_to_delete_list( "phAI_Referee",
		del_phAI_Referee);

	return 0;
}

phAI_Referee::phAI_Referee()
{

	if( !(m_ccmd.empty())) return;
}

phAI_Referee::~phAI_Referee()
{
}

int phAI_Referee::call_ccmd( const std::string &key, gmCCArg &args)
{
	std::map <const std::string, int (*)( const gmCCArg &)> ::
		const_iterator iter = m_ccmd.find( key);
	if( iter == m_ccmd.end()) return phAI::call_ccmd( key, args);
	return (iter->second)( args);
}

std::string phAI_Referee::list_ccmd( const std::string &p_prefix)
{
	std::map <const std::string, int (*)( const gmCCArg &)> ::
		const_iterator iter = m_ccmd.begin();
	std::string tmp;
	for( ; iter != m_ccmd.end(); iter++) {
		tmp += p_prefix + phAI_Referee::type() + "::" + (iter->first) +
			"\n";
	}
	tmp += phAI::list_ccmd( p_prefix);
	return tmp;
}


void phAI_Referee::process( ThingManager *tm)
{
	// Make sure there is host referee to think for.
	phReferee *ref;
	{
		ThingControlBlock *h = get_host();
		if( !h) return;
		if( !(h->m_thing->is_a( "phReferee"))) return;
		ref = (phReferee *)(h->m_thing);
	}

	// XXX: AI test, spin around in a circle.
	//(ref->draw_context())->rotate( RG_DEGTORAD( 1), rgVector( 0, 1, 0));

//	std::cout << "My host is " << (ref->tcb())->m_key << "\n";
//	std::cout << "My arena is " << ((ref->arena())->tcb())->m_key << "\n";
}
