/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef PLAYER_H
#define PLAYER_H
                                                                                
#include "../things/things.h"

class phTeam;
class phArena;

class phPerson : public gmPhyModel
{
public:
	RPH_THING_MODULE

	phPerson();
	virtual ~phPerson();

	std::string type() const { return std::string( "phPerson");}
		bool is_a( const std::string &s) const {
		if( s != phPerson::type()) return gmPhyModel::is_a( s);
		return true;
	}

	phTeam *team();
	void set_team( ThingControlBlock *p_team) { m_team = p_team;}

	phArena *arena();
	void set_arena( ThingControlBlock *p_arena) { m_arena = p_arena;}

protected:

	/////////////////////////////////////////////////////////////////////
	// Some common "things" that "hockey people" would like to know.
	/////////////////////////////////////////////////////////////////////
	ThingControlBlock *m_arena;
	ThingControlBlock *m_team;		// Which team they belong

private:

	phPerson( const phPerson &);
	phPerson &operator =( const phPerson &);
};

class phPlayer : public phPerson
{
public:
	phPlayer();
	virtual ~phPlayer();

	std::string type() const { return std::string( "phPlayer");}
		bool is_a( const std::string &s) const {
		if( s != phPlayer::type()) return phPerson::is_a( s);
		return true;
	}

	void draw( gmRenderArgs *ra);

protected:

private:
	phPlayer( const phPlayer &);
	phPlayer &operator =( const phPlayer &);
};

#endif
