/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifdef RPH_STATIC_BUILD

// XXX: Header files for "things.h"
#include "../things/things.h"
#include "arena.h"
#include "player.h"
#include "goal.h"
#include "puck.h"
#include "camera.h"
#include "team.h"
#include "coach.h"
#include "referee.h"
#include "ai.h"
#include "ai_coach.h"
#include "ai_referee.h"



// XXX: If a given thing should support being linked statically (for debugging,
//	profiling, etc.) then add it to the function below.
int ThingManager::startup_static_thing_module( const std::string &key,
	std::string &emsg)
{
	std::string mod_name( "mod_" + key);
	#define TMP ::gm_main( &mod_name, ge(), &emsg)
	if( key == "phArena")		return phArena		TMP;
	else if( key == "phPlayer")	return phPlayer		TMP;
	else if( key == "phGoal")	return phGoal		TMP;
	else if( key == "phPuck")	return phPuck		TMP;
	else if( key == "phCamera")	return phCamera		TMP;
	else if( key == "phTeam")	return phTeam		TMP;
	else if( key == "phCoach")	return phCoach		TMP;
	else if( key == "phReferee")	return phReferee	TMP;
	else if( key == "phAI")		return phAI		TMP;
	else if( key == "phAI_Coach")	return phAI_Coach	TMP;
	else if( key == "phAI_Referee")	return phAI_Referee	TMP;
	#undef TMP
	else {
		emsg = "No such static thing module \"" + key + "\"\n";
		return -1;
	}
}

#endif
