/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef TEAM_H
#define TEAM_H

#include "../things/things.h"

class phTeam : public gmThing
{
public:
	RPH_THING_MODULE

	phTeam();
	virtual ~phTeam();

	std::string type() const { return std::string( "phTeam");}
	bool is_a( const std::string &s) const {
		if( s != phTeam::type()) return gmThing::is_a( s);
		return true;
	}

	int call_ccmd( const std::string &key, gmCCArg &args);
	std::string list_ccmd( const std::string &p_prefix);


	ThingControlBlock *get_person( const std::string &p_list,
		const std::string &p_person);

	std::string add_person( const std::string &p_list,
		const std::string &p_person);

	std::string remove_person( const std::string &p_list,
		const std::string &p_person);

	std::string create_person_list( const std::string &key);

	std::string remove_person_list( const std::string &key);

	std::map <const std::string, ThingControlBlock *> *get_person_list(
		const std::string &key);

protected:
	static std::map <const std::string, int (*)( const gmCCArg &)> m_ccmd;

	// XXX: There is only one head coach per team. Extra coaches (if added)
	//	will be placed in the "persons" list.
	ThingControlBlock *m_head_coach;

	// All players, extra coaches, and other team staff are listed here.
	// That is, everyone except the head coach.
	std::map <const std::string,
		std::map <const std::string, ThingControlBlock *> *> m_person;


	std::string add_person(
		std::map <const std::string, ThingControlBlock *> *p_list,
		ThingControlBlock *p_tcb);


	friend int phTeam_add_person( const gmCCArg &p);
	friend int phTeam_add_person_list( const gmCCArg &p);

private:
	phTeam( const phTeam &);
	phTeam &operator =( const phTeam &);
};

#endif
